DECLARE FUNCTION TwoParam! (p1 AS DOUBLE, p2 AS DOUBLE)
DECLARE FUNCTION FourParam! (p1 AS DOUBLE, p2 AS DOUBLE, p3 AS DOUBLE, p4 AS DOUBLE)
DECLARE FUNCTION EightParam! (p1 AS DOUBLE, p2 AS DOUBLE, p3 AS DOUBLE, p4 AS DOUBLE, p5 AS DOUBLE, p6 AS DOUBLE, p7 AS DOUBLE, p8 AS DOUBLE)
'-------------------------------- Function03 -----------------------------'
'                                                                         '
'       This program demonstrates the performance cost of passing         '
'       parameters to functions.  To illustrate this, functions           '
'       are called that accept 2, 4, and 8 parameters.                    '
'                                                                         '
'       The called functions do no work, but simply return a value.       '
'                                                                         '
'-------------------------------------------------------------------------'

' global declarations
'longs
DIM counter     AS LONG         'iteration counter
DIM NumIts      AS LONG         'number of iterations

'singles
DIM starttimer  AS SINGLE       'ticks at start of loop
DIM stoptimer   AS SINGLE       'ticks at loop exit

'doubles
DIM E           AS DOUBLE       'return value for function call

'clear the screen
CLS

'initialize the iteration counter
NumIts = 10000000


'-------------------- Called Function with 2 Parameters --------------------

'display message
PRINT "Calling Function with 2 Parameters ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	E = TwoParam(0!, 0!)

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "2 Parameter function called "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT

'-------------------- End Called 2 Parameter Function ----------------------

'-------------------- Called Function with 4 Parameters --------------------

'display message
PRINT "Calling Function with 4 Parameters ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	E = FourParam(0!, 0!, 0!, 0!)

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "4 Parameter function called "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT

'-------------------- End Called 4 Parameter Function ----------------------

'-------------------- Called Function with 8 Parameters --------------------

'display message
PRINT "Calling Function with 8 Paramters ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	E = EightParam(0!, 0!, 0!, 0!, 0!, 0!, 0!, 0!)

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "8 Parameter function called "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT

'-------------------- End Called 8 Parameter Function ----------------------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END

FUNCTION EightParam (p1 AS DOUBLE, p2 AS DOUBLE, p3 AS DOUBLE, p4 AS DOUBLE, p5 AS DOUBLE, p6 AS DOUBLE, p7 AS DOUBLE, p8 AS DOUBLE)

	'return a value
	EightParam = 0

END FUNCTION

FUNCTION FourParam (p1 AS DOUBLE, p2 AS DOUBLE, p3 AS DOUBLE, p4 AS DOUBLE)

	'return a value
	FourParam = 0


END FUNCTION

FUNCTION TwoParam (p1 AS DOUBLE, p2 AS DOUBLE)

	'return a value
	TwoParam = 0

END FUNCTION

