'-------------------------------- Loop01 ---------------------------------'
'									  '
' This program compares a simple function assignment via a rolled loop	  '
' to one with an unrolled loop.						  '
'									  '
'-------------------------------------------------------------------------'

'global declarations
'longs
Dim counter 	As Long		'iteration counter
Dim rindex	As Long		'array index

'singles
Dim timestart 	As Single	'ticks at start of loop
Dim timestop 	As Single	'ticks at loop exit

'doubles
Dim expvalu 	As Double	'exponential argument factor
Dim r(10) 	As Double	'array to assign

'clear the screen
CLS

'set exonential factor to a made-up value for demo
expvalu = 3.13

'-------------------------------- Rolled Loop Calculation -----------------

'display message
Print "Starting array assignment with rolled loop ..."
Print

'start the timer
timestart = TImer

'begin the rolled calculation
For counter = 1 to 10000000

	'actual array assignment in rolled loop
	For rindex = 1 to 10

		r(rindex) = exp(rindex * expvalu)

	Next rindex

Next counter

'stop the timer
timestop = Timer 

'display the result
Print "Assigned array with rolled loop in "; timestop - timestart; " seconds"
Print

'--------------------------------- End Rolled Loop Calculation -------------

'--------------------------------- Unrolled Loop Calculation ---------------

'display message
Print "Starting array assignment with unrolled loop ..."
Print

'start the timer
timestart = Timer

'begin the unrolled calculation
For counter = 1 to 10000000

	'actual array assignment in unrolled loop
	r(1) = exp(expvalu)
	r(2) = exp(2 * expvalu)
	r(3) = exp(3 * expvalu)
	r(4) = exp(4 * expvalu)
	r(5) = exp(5 * expvalu)
	r(6) = exp(6 * expvalu)
	r(7) = exp(7 * expvalu)
	r(8) = exp(8 * expvalu)
	r(9) = exp(9 * expvalu)
	r(10) = exp(10 * expvalu)

Next counter

'stop the timer
timestop = Timer

'display the result
Print "Assigned array with unrolled loop in "; timestop - timestart; " seconds"
Print

'------------------------------------- End Unrolled Loop Calculation --------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END