VERSION 5.00
Begin VB.Form frmLookUp03 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "LookUp03 - Some Additional LookUp Demos"
   ClientHeight    =   5025
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7095
   Icon            =   "frmLookUp03.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5025
   ScaleWidth      =   7095
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame2 
      Caption         =   "LookUp Table"
      Height          =   2775
      Left            =   4080
      TabIndex        =   1
      Top             =   240
      Width           =   2655
      Begin VB.CommandButton cmdpwrxLU 
         Caption         =   "x^y"
         Height          =   495
         Left            =   840
         TabIndex        =   7
         Top             =   1920
         Width           =   855
      End
      Begin VB.CommandButton cmdLogLU 
         Caption         =   "Ln(x)"
         Height          =   495
         Left            =   840
         TabIndex        =   5
         Top             =   1200
         Width           =   855
      End
      Begin VB.CommandButton cmdSineLU 
         Caption         =   "Sine(x)"
         Height          =   495
         Left            =   840
         TabIndex        =   3
         Top             =   480
         Width           =   855
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Explicit Calculation"
      Height          =   2775
      Left            =   480
      TabIndex        =   0
      Top             =   240
      Width           =   2415
      Begin VB.CommandButton cmdpwrxExp 
         Caption         =   "x^y"
         Height          =   495
         Left            =   720
         TabIndex        =   6
         Top             =   1920
         Width           =   855
      End
      Begin VB.CommandButton cmdLogExp 
         Caption         =   "Ln(x)"
         Height          =   495
         Left            =   720
         TabIndex        =   4
         Top             =   1200
         Width           =   855
      End
      Begin VB.CommandButton cmdSinExp 
         Caption         =   "Sine(x)"
         Height          =   495
         Left            =   720
         TabIndex        =   2
         Top             =   480
         Width           =   855
      End
   End
   Begin VB.Label Label2 
      Height          =   1575
      Left            =   4080
      TabIndex        =   9
      Top             =   3240
      Width           =   2655
   End
   Begin VB.Label Label1 
      Height          =   1575
      Left            =   480
      TabIndex        =   8
      Top             =   3240
      Width           =   2415
   End
End
Attribute VB_Name = "frmLookUp03"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const cNumLoop As Long = 50000000

Public StartTimer As Single
Public StopTimer As Single

Public Angle As Double
Public Base As Double
Public Expon As Double
Public LogArg As Double

Dim SinLU(70000) As Double
Dim LogLU(70000) As Double
Dim exponLU(70000) As Double

Private Sub cmdLogExp_Click()

    Dim Counter As Long
    
    Dim Value As Double
    
    Label1.Caption = "Computing ..."
    DoEvents
    
    StartTimer = Timer
    
    For Counter = 1 To cNumLoop

        Value = Log(LogArg)

    Next Counter

    StopTimer = Timer
    
    Label1.Caption = "Computed " & Str(cNumLoop) & " ln(x) calculations in " & _
            Str(StopTimer - StartTimer) & " seconds."

End Sub

Private Sub cmdLogLU_Click()

    Dim Counter As Long
    Dim LogIndex As Long
    
    Dim Value As Double
    
    Label2.Caption = "Computing ..."
    DoEvents
    
    StartTimer = Timer
    
    For Counter = 1 To cNumLoop

        Value = LogLU(LogArg * 10000)

    Next Counter

    StopTimer = Timer
    
    Label2.Caption = "Looked Up ln(x) " & Str(cNumLoop) & " times in " & _
            Str(StopTimer - StartTimer) & " seconds."

End Sub

Private Sub cmdpwrxExp_Click()

    Dim Counter As Long
    
    Dim Value As Double
    
    Label1.Caption = "Computing ..."
    DoEvents
    
    StartTimer = Timer
    
    For Counter = 1 To cNumLoop

        Value = Base ^ Expon

    Next Counter

    StopTimer = Timer
    
    Label1.Caption = "Computed " & Str(cNumLoop) & " 6.345^4.78 calculations in " & _
            Str(StopTimer - StartTimer) & " seconds."

End Sub

Private Sub cmdpwrxLU_Click()

    Dim Counter As Long
    
    Dim Value As Double
    
    Label2.Caption = "Computing ..."
    DoEvents
    
    StartTimer = Timer
    
    For Counter = 1 To cNumLoop

        Value = exponLU(Expon * 10000)

    Next Counter

    StopTimer = Timer
    
    Label2.Caption = "Computed 6.345^4.78 " & Str(cNumLoop) & " times in " & _
            Str(StopTimer - StartTimer) & " seconds."

End Sub

Private Sub cmdSineLU_Click()

    Dim Counter As Long
    
    Dim Value As Double
    
    Label2.Caption = "Computing ..."
    DoEvents
    
    StartTimer = Timer
    
    For Counter = 1 To cNumLoop

        Value = SinLU(Angle * 10000)

    Next Counter

    StopTimer = Timer
    
    Label2.Caption = "Looked Up sin(x) " & Str(cNumLoop) & " times in " & _
            Str(StopTimer - StartTimer) & " seconds."

End Sub

Private Sub cmdSinExp_Click()

    Dim Counter As Long
    
    Dim Value As Double
    
    Label1.Caption = "Computing ..."
    DoEvents
    
    StartTimer = Timer
    
    For Counter = 1 To cNumLoop

        Value = Sin(Angle)

    Next Counter

    StopTimer = Timer
    
    Label1.Caption = "Computed " & Str(cNumLoop) & " sin(x) calculations in " & _
            Str(StopTimer - StartTimer) & " seconds."

End Sub

Private Sub Form_Load()

    Dim Counter As Long
    
    Dim luAngle As Double
    Dim luExpon As Double
    Dim luLogArg As Double
    
    Angle = 1.31266
    Base = 6.345
    Expon = 4.78
    LogArg = 5.32
    
    For Counter = 1 To 70000
    
        luAngle = Counter / 10000
        SinLU(Counter) = Sin(luAngle)
        
        luExpon = Counter / 10000
        exponLU(Counter) = Base ^ luExpon
    
        luLogArg = Counter / 10000
        LogLU(Counter) = Log(luLogArg)
    
    Next Counter

End Sub
