// Function04Dlg.cpp : implementation file
//
// This program compares passing individual data to passing
// an array reference.  No work is done in the functions.

#include "stdafx.h"
#include "Function04.h"
#include "Function04Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// global declarations
static int cNumIts = 100000000;

//functions
double Pass6 (double a, double b, double c, double d, double e, 
			  double f);

double PassRef (double *h);

/////////////////////////////////////////////////////////////////////////////
// CFunction04Dlg dialog

CFunction04Dlg::CFunction04Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFunction04Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFunction04Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFunction04Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFunction04Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFunction04Dlg, CDialog)
	//{{AFX_MSG_MAP(CFunction04Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunction04Dlg message handlers

BOOL CFunction04Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFunction04Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFunction04Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//calls a function passing six double precision parameters
void CFunction04Dlg::OnButton1() 
{
	//Local Declarations
	//Integers
	int counter;			  //iteration counter
	int j;					  //output string pointer

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double x[6];			  //array to be sent
    double dummy;			  //return value

	//characters
	char buffer[200];		//output string

    //initialize with some values to pass
	x[0] = 1.234;
	x[1] = 2.765;
	x[2] = 3.718;
	x[3] = 9.234;
	x[4] = 0.003;
	x[5] = -5.443;
    
	//start the timer
    starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    

        //pass the six values
		dummy = Pass6(x[0], x[1], x[2], x[3], x[4], x[5]);

    }
    
	//stop the timer
    stoptime = GetTickCount();      
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Passed Six Values to Function 100,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	
	
}

//passes a single int array reference to a function
void CFunction04Dlg::OnButton2() 
{
	//Local Declarations
	//Integers
	int counter;			  //iteration counter
	int j;					  //output string pointer

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double x[6];			  //array to be sent
    double dummy;			  //return value

	//characters
	char buffer[200];		//output string

    //initialize with some values to pass
	x[0] = 1.234;
	x[1] = 2.765;
	x[2] = 3.718;
	x[3] = 9.234;
	x[4] = 0.003;
	x[5] = -5.443;
    
	//start the timer
    starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    

        //pass the single reference
		dummy = PassRef(x);

    }
    
	//stop the timer
    stoptime = GetTickCount();      
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Passed Single Reference to Function 100,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	
}

//the function that receives six double parameters
double Pass6 (double a, double b, double c, double d, double e, 
			  double f)

{

	return(0);

}

//the function that receives a single array reference
double PassRef (double *h)
{

	return(0);

}