// NumDemo.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "NumDemo.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


//exported lj energy function for visual basic
double _stdcall vbLJEnergy(double r, double Sigma6)
{

	double r1;
	double r2;
	double sigma12;
	double energy;

	r1 = r * r * r * r * r * r;
	r2 = r1 * r1;

	sigma12 = Sigma6 * Sigma6;

	energy = sigma12/r2 - Sigma6/r1;

	return(energy);

}

//exported lj energy function for c
double fnLJEnergy(double r, double Sigma6)
{

	double r1;
	double r2;
	double sigma12;
	double energy;

	r1 = r * r * r * r * r * r;
	r2 = r1 * r1;

	sigma12 = Sigma6 * Sigma6;

	energy = sigma12/r2 - Sigma6/r1;

	return(energy);

}

