/////////////////////////// genMatrix Header File ////////////////////
//																    //
//  Defines the functions and types needed for the genMatrix part   //
//  of the genMath Library.											//
//																	//
//////////////////////////////////////////////////////////////////////

//////////////////////////////// Data Types //////////////////////////

//////////////////////////////// FUNCTIONS ///////////////////////////

//generic matrix multiply by scalar
int genMatrixScale(
				   float *MatrixA, 
				   int DimenM, 
				   int DimenN, 
				   float Scale,
				   float *Result);

//generic nxn matrix multiplication
int genMatrixMultnxn(
					 float *MatrixA,
					 float *MatrixB,
					 int	dimen,
					 float *MatrixC);

//generic trace of nxn matrix
int genMatrixTrace(
				   float *Matrix,
				   int	 dimen,
				   float *trace);

//generic matrix mult. mxn X nxp matrixes
int genMatrixMult(
					 float *MatrixA,
					 int	dimM,
					 int	dimN,
					 float *MatrixB,
					 int	dimP,
					 float *MatrixProd);

//addition of two generic mxn matrices
int	genMatrixAdd(
				 float	*MatrixA,
				 float	*MatrixB,
				 int	dimM,
				 int	dimN,
				 float	*MatrixSum);

//transpose a generic mxn matrix
int genMatrixTranspose(
					   float	*Matrix,
					   int		dimM,
					   int		dimN,
					   float	*Transpose);



