'-------------------------------- Data01 ---------------------------------'
'									  '
' This program compares implicit to explicit variable declaration	  '
'									  '
'-------------------------------------------------------------------------'

'global declarations
'longs
Dim counter 	As Long		'iteration counter
Dim misx	As long		'base for mismatched routine
Dim misy	As long		'exponent for mismatched routine

'singles
Dim timestart 	As Single	'ticks at start of loop
Dim timestop 	As Single	'ticks at loop exit

'doubles
Dim x 		as double	'base
Dim y		as double	'exponent

'clear the screen
CLS


'-------------------------------- Implicit Declaration -----------------

'display message
Print "Starting routine with implicit declaration ..."
Print

'assign the base
impx = 2

'assign the exponent
impy = 4


'start the timer
timestart = TImer


For thiscounter = 1 to 10000000

        'compute x^y
        result = impx ^ impy
 
Next thiscounter

'stop the timer
timestop = Timer 

'display the result
Print "Computed with implicitly declared data in "; timestop - timestart; " seconds"
Print

'------------------------ End Implicit Declaration Calculation -------------

'--------------------------- Mismatched Explicit Declaration ---------------

'display message
Print "Starting mismatched explicit declaration ..."
Print

'assign the base
misx = 2
    
'assign the exponent
misy = 4

'start the timer
timestart = Timer


For counter = 1 to 10000000

        'compute x^y
        result = misx ^ misy
 
Next counter

'stop the timer
timestop = Timer

'display the result
Print "Computed with mismatched explicit declaration in "; timestop - timestart; " seconds"
Print
'------------- End Mismatched Explicit Declaration Calculation -------------

'------------------------------ Correct Explicit Declaration ---------------

'display message
Print "Starting correct explicit declaration ..."
Print

'assign the base
x = 2
    
'assign the exponent
y = 4

'start the timer
timestart = Timer


For counter = 1 to 10000000

        'compute x^y
        result = x ^ y
 
Next counter

'stop the timer
timestop = Timer

'display the result
Print "Computed with correct explicit declaration in "; timestop - timestart; " seconds"
Print

'-------------------- End Correct Explicit Declaration Calculation --------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END