VERSION 5.00
Begin VB.Form frmPar01 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Single Node 2-D Laplace Eqn Solver"
   ClientHeight    =   8175
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   10245
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   545
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   683
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.CommandButton Command1 
      Caption         =   "End"
      Height          =   495
      Left            =   8880
      TabIndex        =   3
      Top             =   2520
      Width           =   1215
   End
   Begin VB.CommandButton cmdCalcLaplace 
      Caption         =   "Solve Laplace Eqn"
      Height          =   615
      Left            =   8880
      TabIndex        =   1
      Top             =   720
      Width           =   1455
   End
   Begin VB.PictureBox Picture1 
      Height          =   3090
      Left            =   600
      ScaleHeight     =   202
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   202
      TabIndex        =   0
      Top             =   600
      Width           =   3090
   End
   Begin VB.Label Label1 
      Height          =   615
      Left            =   8880
      TabIndex        =   2
      Top             =   1560
      Width           =   1335
   End
End
Attribute VB_Name = "frmPar01"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const cSourceVel As Single = 100


Private Sub cmdCalcLaplace_Click()

    Dim XCounter As Long
    Dim YCounter As Long
    Dim ItCounter As Long
    
    Dim ContourLo As Single
    Dim ContourHi As Single
    
    
    Label1.Caption = "Computing ..."
    DoEvents
    
    ContourLo = cSourceVel * 0.45
    ContourHi = cSourceVel * 0.55
    
    For ItCounter = 1 To 200000
    
    For XCounter = 1 To 200
    
        
        For YCounter = 1 To 200
            
            If Soln(XCounter, YCounter).Status = 0 Then
            
            
                    
                    Soln(XCounter, YCounter).Soln = Soln(XCounter - 1, YCounter).Soln + Soln(XCounter, YCounter - 1).Soln + _
                        Soln(XCounter + 1, YCounter).Soln + Soln(XCounter, YCounter + 1).Soln

                    Soln(XCounter, YCounter).Soln = Soln(XCounter, YCounter).Soln * 0.25

            End If
        
        Next YCounter
    
    Next XCounter
    
    XCounter = 0
    YCounter = 0
    
    'For XCounter = 0 To 500
    
    '    For YCounter = 0 To 500
        
            'If Soln(XCounter, YCounter).Status = 2 Then
            
                If XCounter = 0 Then
                    
                    Soln(XCounter, YCounter).Soln = Soln(XCounter + 1, YCounter).Soln

                ElseIf XCounter = 500 Then
                    
                    Soln(XCounter, YCounter).Soln = Soln(XCounter - 1, YCounter).Soln

                ElseIf YCounter = 0 Then
                    
                    Soln(XCounter, YCounter).Soln = Soln(XCounter, YCounter + 1).Soln

                ElseIf YCounter = 500 Then
                    
                    Soln(XCounter, YCounter).Soln = Soln(XCounter, YCounter - 1).Soln

                Else
                
                    Soln(XCounter, YCounter).Soln = Soln(XCounter - 1, YCounter).Soln + Soln(XCounter, YCounter - 1).Soln + _
                        Soln(XCounter + 1, YCounter).Soln + Soln(XCounter, YCounter + 1).Soln

                    Soln(XCounter, YCounter).Soln = Soln(XCounter, YCounter).Soln * 0.25

                End If
                
            'End If
                    
    '    Next YCounter
            
    'Next XCounter

    If ItCounter Mod 100 = 0 Then
     Label1.Caption = Str(ItCounter)
     DoEvents
    End If
    
    If ItCounter Mod 1000 = 0 Then
        Paint_Final_Soln
    End If

    Next ItCounter
    
    Paint_Final_Soln

End Sub



Private Sub Command1_Click()

    End

End Sub

Private Sub Form_Load()

    Picture1.FillStyle = vbSolid

    frmPar01.Show
    
    DoEvents

    Initialize_Boundary

End Sub

Private Sub Initialize_Boundary()

    Dim dummy As Long
    Dim hDCon As Long
    Dim XIndex As Long
    Dim YIndex As Long
    
    Dim XCounter As Single
    Dim YCounter As Single
    
    hDCon = Picture1.hDC
    
    Picture1.ForeColor = vbBlack
    Picture1.FillColor = vbBlack
    
    dummy = Rectangle(hDCon, 0, 0, 1, 201)
    
    Picture1.ForeColor = vbBlue
    Picture1.FillColor = vbBlue
    
    dummy = Rectangle(hDCon, 60, 0, 80, 90)
    dummy = Rectangle(hDCon, 60, 110, 80, 201)
    
    Picture1.ForeColor = vbGreen
    Picture1.FillColor = vbGreen
    
    dummy = Rectangle(hDCon, 120, 0, 140, 90)
    dummy = Rectangle(hDCon, 120, 110, 140, 201)
    
    DoEvents
    
    For XCounter = 0 To 200
    
        XIndex = CLng(XCounter)
    
        For YCounter = 0 To 200
        
            YIndex = CLng(YCounter)
        
            Select Case Picture1.Point(XCounter, YCounter)
            
            Case vbBlack
            
                Soln(XIndex, YIndex).Soln = -cSourceVel
                Soln(XIndex, YIndex).Status = 1
                
            Case vbBlue
            
                Soln(XIndex, YIndex).Soln = cSourceVel
                Soln(XIndex, YIndex).Status = 1
                
            Case vbGreen
            
                Soln(XIndex, YIndex).Soln = 3 * cSourceVel
                Soln(XIndex, YIndex).Status = 1
                
            End Select
            
            
            
        Next YCounter
        
    Next XCounter
            
      Print Soln(385, 0).Soln

End Sub

Private Sub Paint_Final_Soln()

    Dim CurRed As Long
    
    Dim XCounter As Long
    Dim YCounter As Long
    
    Dim ContourCount As Single
    Dim ContourLo As Single
    Dim ContourHi As Single
    
    'Label1.Caption = "Painting Solution"
    'DoEvents
    
    For XCounter = 0 To 200
    
        For YCounter = 0 To 200
        
            
            If Soln(XCounter, YCounter).Status <> 1 Then
            
                Picture1.PSet (XCounter, YCounter), &H8000000F
        
                'For ContourCount = 0.001 To 0.9 Step 0.05
                
                'ContourLo = 2 * cSourceVel * (ContourCount - 0.005)
                'ContourHi = 2 * cSourceVel * (ContourCount + 0.005)
                
                'If Soln(XCounter, YCounter).Soln > ContourLo And _
                    Soln(XCounter, YCounter).Soln < ContourHi Then
                
                        
                        'CurRed = Int(ContourCount * 16777000)
                        CurRed = Soln(XCounter, YCounter).Soln / cSourceVel * 16777000
                            
                        Picture1.PSet (XCounter, YCounter), CurRed 'RGB(CurRed, 50, 100)
                
                'End If
                
                'Next ContourCount
            
            End If
            
            
        
        Next YCounter
        
    Next XCounter
    
    
    
End Sub
