// Data04Dlg.cpp : implementation file
//
// This program compares the type specific operators.  In C
// the division operator is overloaded.

#include "stdafx.h"
#include "Data04.h"
#include "Data04Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//global declarations
int cNumIts = 100000000;

/////////////////////////////////////////////////////////////////////////////
// CData04Dlg dialog

CData04Dlg::CData04Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CData04Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CData04Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CData04Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CData04Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CData04Dlg, CDialog)
	//{{AFX_MSG_MAP(CData04Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CData04Dlg message handlers

BOOL CData04Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CData04Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CData04Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//compute 100/3 using float data and float division
void CData04Dlg::OnButton1() 
{
	//local declarations
	//integers
	int j;						//output string pointer
	int counter;				//iteration counter
	unsigned int result;		//result

	//floats
	float x = 100;				//dividend
	float y = 3;				//divisor

	//doubles
	double starttime;			//system 'ticks' at start of loop
	double stoptime;			//system 'ticks' at loop exit
	double ElapsedTime;			//system ticks during loop

	//character strings
	char buffer[200];			//output string

	//start the timer
    starttime = GetTickCount();

	for(counter=1; counter <= cNumIts; ++counter){
        
		result = (int)(x/y);
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build output string and display result in message box
	j = sprintf(buffer,"%s%d%s%g", "Computed float/float ", cNumIts, " times with memory references in ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.\n");
	j += sprintf(buffer + j, "%s%d", "Result = ", result);

	MessageBox(buffer,
					 "float / float",
					 MB_OK | MB_ICONEXCLAMATION);	
}

//computes int/int; operator specifies integer division
void CData04Dlg::OnButton3() 
{
	//local declarations
	//integers
	int j;						//output string pointer
	int counter;				//iteration counter
	unsigned int result;		//result
	unsigned int x = 100;		//dividend
	unsigned int y = 3;			//divisor

	//doubles
	double starttime;			//system 'ticks' at start of loop
	double stoptime;			//system 'ticks' at loop exit
	double ElapsedTime;			//system ticks during loop

	//character strings
	char buffer[200];			//output string

	//start the timer
    starttime = GetTickCount();

	for(counter=1; counter <= cNumIts; ++counter){
       
		result = x/y;
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build output string and display result in message box
	j = sprintf(buffer,"%s%d%s%g", "Computed float/float ", cNumIts, " times with memory references in ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.\n");
	j += sprintf(buffer + j, "%s%d", "Result = ", result);

	MessageBox(buffer,
					 "float / float",
					 MB_OK | MB_ICONEXCLAMATION);	
}
