/////////////////////////// calculus Header File /////////////////////
//																    //
//  Defines the functions and types needed for the calculus part    //
//  of the genMath Library.											//
//																	//
//////////////////////////////////////////////////////////////////////

////////////////////////////// FUNCTIONS ///////////////////////////

//generic Trapezoidal Rule Integration
int genTrap(
			float	*fx,
			float	a,
			float	b,
			int		n,
			float	*I);

//Trapezoidal Rule Integration for function of 100 elements
int Trap100(
			float	*fx,
			float	a,
			float	b,
			float	*I);

//Trapezoidal Rule Integration for function of 500 elements
int Trap500(
			float	*fx,
			float	a,
			float	b,
			float	*I);

//Trapezoidal Rule Integration for function of 512 elements
int Trap512(
			float	*fx,
			float	a,
			float	b,
			float	*I);

//Trapezoidal Rule Integration for function of 1000 elements
int Trap1000(
			float	*fx,
			float	a,
			float	b,
			float	*I);

//Trapezoidal Rule Integration for function of 1024 elements
int Trap1024(
			float	*fx,
			float	a,
			float	b,
			float	*I);

//Trapezoidal Rule Integration for function of 2048 elements
int Trap2048(
			float	*fx,
			float	a,
			float	b,
			float	*I);

//Trapezoidal Rule Integration for function of 4096 elements
int Trap4096(
			float	*fx,
			float	a,
			float	b,
			float	*I);

//Trapezoidal Rule Integration for function of 5000 elements
int Trap5000(
			float	*fx,
			float	a,
			float	b,
			float	*I);