/////////////////////////// genMisc Header File //////////////////////
//																    //
//  Defines the functions and types needed for the genMisc part     //
//  of the genMath Library.											//
//																	//
//////////////////////////////////////////////////////////////////////

//////////////////////////////// Data Types //////////////////////////

//////////////////////////////// DEFINES /////////////////////////////

#define	sigmato6	sigma6 = sigma * sigma * sigma * sigma * sigma * sigma
#define sigmato12	sigma12 = sigma6 * sigma6
//////////////////////////////// FUNCTIONS ///////////////////////////

//single particle pair LJ Energy
float HomogLJEnergy12d(
					   float r, 
					   float sigma, 
					   float depth);

//LJ collection of particles Energy
float HomogLJEnergyM2d(
					   float	*x,
					   float	*y,
					   int		NumPart,
					   float	sigma,
					   float	depth);

//single particle - collection of particle LJ Energy
float HomogLJdEnergy2d(
					   float	*x,
					   float	*y,
					   int		NumPart,
					   float	sigma,
					   float	depth,
					   int		Part)